package edu.georgetown.gucs.tokenizers;

import edu.georgetown.gucs.utility.ExceptionHandler;
import edu.georgetown.gucs.utility.SdTextException;
import edu.georgetown.gucs.utility.Token;

import java.util.Collections;
import java.util.List;
import java.util.Vector;

/**
 * @author Evan
 * @since 3/19/15.
 */
public class MemoryTokenizer extends Tokenizer {

    private List<String> tokenizers_ = new Vector<>();
    private String splitter_ = null;
    ParseTokenizers parsedTokens_;

    public MemoryTokenizer(String tokenizers) {
        addTokenizers(tokenizers);
    }

    public MemoryTokenizer() {
        //satisfy build object default constructor
    }

    //read file
    public void tokenizeString(String str) throws SdTextException {
        try {
            TokenizerList tokenizerList = new TokenizerList(this.tokenizers_);

            tokenizerList.setSplitter(this.splitter_);
            this.tokenVectorMap = tokenizerList.tokenizeString(str);

        } catch (SdTextException sdtext) {
            throw sdtext;
        } catch (Exception e) {
            ExceptionHandler.handleException(e);
        }
    }

    public List<Token> tokenize(String str) {

        this.parsedTokens_ = new ParseTokenizers(str);
        List<Token> tokens = parsedTokens_.readString();
        tokenVectorMap = parsedTokens_.getTokenVectorMap();

        return tokens;

    }

    private void addTokenizers(String tokenizers) {

        Collections.addAll(tokenizers_, tokenizers.split("\\s"));

    }

}
